#!/usr/bin/env python

# Python imports
import sys

# Lib imports

# Application imports
from setuptools import setup, find_packages
from setuptools.command.test import test as TestCommand



with open("README.md", "r") as fh:
    long_description = fh.read()



class PyTest(TestCommand):
    user_options = [("pytest-args=", "a", "Arguments to pass to pytest")]

    def initialize_options(self):
        TestCommand.initialize_options(self)
        self.pytest_args = []

    def run_tests(self):
        import pytest  # import here, cause outside the eggs aren't loaded
        errno = pytest.main(self.pytest_args)
        sys.exit(errno)



setup(
    name             = "PyLSPClient",
    version          = "0.0.1",
    author           = "ITDominator",
    author_email     = "1itdominator@gmail.com",
    description      = "Python LSP client implementation cloned from Avi Yeger's efforts",
    long_description = long_description,
    long_description_content_type = "text/markdown",
    url              = "https://code.itdominator.com/itdominator/PyLSPClient",
    packages         = find_packages(),
    tests_require    = ["pytest", "pytest_mock"],
    cmdclass         = {"test": PyTest},
)